; ------------------------------------------------------------------------------------------------------------------------
; macros	for invite
; ------------------------------------------------------------------------------------------------------------------------

; from up and face direction make a matrix..
;
; input:	
;		up	 	: up direction in this frame
;		face	: face - face direction in this frame
; return m0,m1,m2,m3

			.macro	makeFaceMatrix	up,face,m0,m1,m2,m3


			.endm
; ------------------------------------------------------------------------------------------------------------------------

; invertOrthoMatrix
;
;			given a 4x4 with rotation part . invert it.. so, transpose it a bit
;
;
;
;

			.macro	invOrthoMatrix		out_m,in_m

; transpose 

			mfir.w	\out_m[0],vi00				; clear .---w
			mfir.w	\out_m[1],vi00				; clear .---w
			mfir.w	\out_m[2],vi00				; clear .---w
			move.w	\out_m[3],vf00				; set .---1.0

		  	add.x		\out_m[0],\in_m[0],vf00 		; .0x--w
		  	add.y		\out_m[1],\in_m[1],vf00		; .1-y-w
		  	add.z		\out_m[2],\in_m[2],vf00		; .2--zw
				
			mr32.x	\out_m[1],\in_m[0]				;  .1xy-w
			mr32.y	\out_m[2],\in_m[1]				;	.2-yzw
			
			addx.y	\out_m[0],vf00,\in_m[1] 		; .0xy-w
			addy.z	\out_m[1],vf00,\in_m[2]		; .1xyzw - done

			addz.x	\out_m[2],vf00,\in_m[0]		; .2xyzw
			addx.z	\out_m[0],vf00,\in_m[2]		; .0xyzw	 - done

; now -R[t]

			adda.xyz		acc,vf00,vf00					; acc.xyz=0
			msubax.xyz	acc,\out_m[0],\in_m[3]
			msubay.xyz	acc,\out_m[1],\in_m[3]
			msubz.xyz	\out_m[3],\out_m[2],\in_m[3]

			.endm

; ------------------------------------------------------------------------------------------------------------------------

; from angles, make rotation matrix 
;
;	input:
;		angles.xyz		- angles
;	output:
;		m0.xyzw			xyz are rot, w=0;
;		m1.xyzw
;		m2.xyzw
;

			.macro	rotMatrix		angles,m0,m1,m2
			.endm



; ------------------------------------------------------------------------------------------------------------------------

; set unit matrix in m0..m3

		.macro	unitMatrix	mat
		move		\mat[3],vf00		 		; m3 is 0 0 0 1
		mr32		\mat[2],vf00					; m2 is 0 0 1 0		
		mr32		\mat[1],\mat[2]					; m1 is 0 1 0 0		
		addw.x	\mat[0],vf00,vf00			; m0 is 1 - - -
		sub.yzw	\mat[0],vf00,vf00			; m0 is 1 0 0 0  

		.endm

		.macro	saveMatrix		mat,offset,base
		sq			\mat[0],\offset(\base)
		sq			\mat[1],1+\offset(\base)
		sq			\mat[2],2+\offset(\base)
		sq			\mat[3],3+\offset(\base)
		.endm

		.macro	loadMatrix		mat,offset,base
		lq			\mat[0],\offset(\base)
		lq			\mat[1],1+\offset(\base)
		lq			\mat[2],2+\offset(\base)
		lq			\mat[3],3+\offset(\base)
		.endm


; rot trans persp point xyz, colour col


		.macro	rtp_Point	mat,x_,y_,z_,col

		loi	 		\x_
		mulai	  		acc,\mat[0],i
		loi	  		\y_
		maddai	  	acc,\mat[1],i
		loi	  		\z_
		maddai	  	acc,\mat[2],i
		maddw			sc_pt,\mat[3],vf00

		div	 		q,vf00w,sc_ptw
		mulq 			sc_pt,sc_pt,q	
		add			sc_pt,sc_pt,gsCentre
		ftoi4			fx_pt,sc_pt
		sq				fx_pt,pt_xyzf2(out_p)
		sq				\col,pt_rgba(out_p)
		iaddiu		out_p,out_p,pt_sizeof

		.endm





FBT	.equ	0
CST	.equ	4	 
SST	.equ	8

;	const	.x=MAX_FLOAT_VAL
;			.y=PITO4
;			.z=SIN_1
;			.w=COS_2

		.macro	makeRotate	

		lq				const,ib_angConstants(vi00)	 	; load helpers
		lq				s_taylor,ib_sTaylor(vi00)
		lq				c_taylor,ib_cTaylor(vi00)

		vzero			sin			; basically, w has to be zero!
		vzero			cos

		maxw			ones,vf00,vf00			 		; get register of 1.0
		sub			zero,vf00,vf00
		sub  			mone,zero,ones

		sq				zero,FBT+0(vi00):FBT 	; declare tag to ensure in-order memory access for this address
		sq				ones,FBT+1(vi00):FBT	
		sq				zero,FBT+2(vi00):FBT
		sq				ones,FBT+3(vi00):FBT

		sq				ones,CST+0(vi00):CST
		sq		  		mone,CST+1(vi00):CST
		sq		  		mone,CST+2(vi00):CST
		sq		  		ones,CST+3(vi00):CST

		sq		 		ones,SST+0(vi00):SST
		sq		  		ones,SST+1(vi00):SST
		sq		  		mone,SST+2(vi00):SST
		sq				mone,SST+3(vi00):SST

		mulx.xyz		ssign,angles,const		; max value
		minix.xyz	ssign,ssign,vf00			; clamp above 0.0
		loi			-2.0
		maxi.xyz		ssign,ssign,i	 			; clamp to -2 below
		addw.xyz		ssign,ssign,vf00			; now.. -1 or 1	 !

		muly.xyz		angles,angles,const		; get 0-2pi to 0-4 to PITO4
		
		abs.xyz		angles,angles				; abs value
		ftoi0.xyz	iang,angles					; integer parts
		
		iaddiu 		three,vi00,3
		
		mtir			x_int,iangx
		iand   		x_int,x_int,three
		lq.x   		flip,FBT(x_int):FBT
		lq.x   		sin_sign,SST(x_int):SST
		lq.x  		cos_sign,CST(x_int):CST
		
		mtir			y_int,iangy
		iand   		y_int,y_int,three
		lq.y   		flip,FBT(y_int):FBT
		lq.y   		sin_sign,SST(y_int):SST
		lq.y  		cos_sign,CST(y_int):CST
		
		mtir   		z_int,iangz
		iand   		z_int,z_int,three
		lq.z   		flip,FBT(z_int):FBT
		lq.z 			sin_sign,SST(z_int):SST
		lq.z  		cos_sign,CST(z_int):CST
		
		mul.xyz		sin_sign,ssign,sin_sign
		
		itof0.xyz	ifang,iang
		sub.xyz		angles,angles,ifang	   		; angle 0-1
		
		mul.xyz		ang2,angles,angles
		mul.xyz		ang3,ang2,angles
		mul.xyz		ang4,ang2,ang2
		mul.xyz		ang5,ang3,ang2
		mul.xyz		ang6,ang3,ang3
		mul.xyz		ang7,ang3,ang4
		mul.xyz		ang8,ang4,ang4
		mul.xyz		ang9,ang5,ang4
		mul.xyz		ang10,ang5,ang5
		
		mulaz.xyz	acc,angles,const
     	maddax.xyz	acc,ang3,s_taylor
     	madday.xyz	acc,ang5,s_taylor
     	maddaz.xyz	acc,ang7,s_taylor
   	maddw.xyz	tsin,ang9,s_taylor
		
		
		mula.xyz		acc,ones,ones
		maddaw.xyz	acc,ang2,const
		maddax.xyz	acc,ang4,c_taylor
		madday.xyz	acc,ang6,c_taylor
		maddaz.xyz	acc,ang8,c_taylor
		maddw.xyz	tcos,ang10,c_taylor
		
		sub.xyz		mflip,ones,flip
		mula.xyz		acc,tcos,flip  		; flip=1.0 if flip, else 0.0
		madd.xyz		sin,tsin,mflip
		
		mula.xyz		acc,tsin,flip  		; flip=1.0 if flip, else 0.0
		madd.xyz		cos,tcos,mflip 		
		
		mul.xyz		sin,sin,sin_sign	; set correct signs
		mul.xyz		cos,cos,cos_sign

	

;	out_mat->m[0][0] = cy*cz;
;	out_mat->m[0][1] = cy*sz;
;	out_mat->m[0][2] = -sy;
;	out_mat->m[0][3] = 0;

;	out_mat->m[1][0] = sx*sy*cz-sz*cx;
;	out_mat->m[1][1] = sx*sy*sz+cx*cz;
;	out_mat->m[1][2] = sx*cy;
;	out_mat->m[1][3] = 0;

;	out_mat->m[2][0] = cx*sy*cz+sx*sz;
;	out_mat->m[2][1] = cx*sy*sz-sx*cz;
;	out_mat->m[2][2] = cx*cy;
;	out_mat->m[2][3] = 0;

;	out_mat->m[3][0] = 0.0f;
;	out_mat->m[3][1] = 0.0f;
;	out_mat->m[3][2] = 0.0f;
;	out_mat->m[3][3] = 1.0f;

; zero input matrix, apart from row3, which is vf00

;		sub			objMat[0],vf00,vf00
;		sub			objMat[1],vf00,vf00
;		sub			objMat[2],vf00,vf00

	mfir		objMat[0],vi00
	mfir		objMat[1],vi00
	mfir		objMat[2],vi00

		move			objMat[3],vf00				; at origin

		
		addz.x		czsz_,vf00,cos
		addz.y		czsz_,vf00,sin
		muly.xy		objMat[0],czsz_,cos	
		suby.z		objMat[0],vf00,sin	  	; done row 0		

		addy.z		czsz_,vf00,cos		 		; czsz_=czszcy
		muly.xy		czsz_,czsz_,sin	  		; czsz_ = sycz,sysz,cy


		mulax.xyz	objMat[1],czsz_,sin
		mr32.yz		cos,cos	  					; y=z term, z= 0
		mr32.yz 		sin,sin						; likewise	
		msuby.xz		objMat[1],cos,sin
		maddx.y		objMat[1],cos,cos


		mulax.xyz	objMat[2],czsz_,cos
		maddy.xz		objMat[2],sin,sin
		msubx.y		objMat[2],cos,sin

		.endm


		.macro	start_letter	char,nlines
txt_\char:
		.word		\nlines,0,0,0
		.endm		
	

		

		.macro	add_line	_x0,_y0,_x1,_y1
		.float	\_x0,\_y0,\_x1,\_y1
		.endm

		
		.macro	msgStart	name
\name:
		.endm

		.macro	msgChar 	c,r,g,b	
		.word		\r,\g,\b,(txt_\c-top)>>4 	; w field
		.endm


		.macro	msgEnd
		.word		0,0,0,0
		.endm


			.macro	msgRing	text,rdist,y_offset,ang_step,init_angle,rot_speed
			.word		(\text-top)>>4
			.float	\rdist,\y_offset,\ang_step
			
			.float	\rot_speed,\init_angle
			.word		0,0
			

			
			.endm


; maximally lame function!
; assume : angles.x = theta,y=phi,z=radius
		
		
		.macro	inFacePolar

		lq				const,ib_angConstants(vi00)	 	; load helpers
		lq				s_taylor,ib_sTaylor(vi00)
		lq				c_taylor,ib_cTaylor(vi00)

		vzero			sin			; basically, w has to be zero!
		vzero			cos

		maxw			ones,vf00,vf00			 		; get register of 1.0
		sub			zero,vf00,vf00
		sub  			mone,zero,ones

		sq				zero,FBT+0(vi00):FBT 	; declare tag to ensure in-order memory access for this address
		sq				ones,FBT+1(vi00):FBT	
		sq				zero,FBT+2(vi00):FBT
		sq				ones,FBT+3(vi00):FBT

		sq				ones,CST+0(vi00):CST
		sq		  		mone,CST+1(vi00):CST
		sq		  		mone,CST+2(vi00):CST
		sq		  		ones,CST+3(vi00):CST

		sq		 		ones,SST+0(vi00):SST
		sq		  		ones,SST+1(vi00):SST
		sq		  		mone,SST+2(vi00):SST
		sq				mone,SST+3(vi00):SST

		mulx.xyw		ssign,angles,const		; max value
		minix.xyw	ssign,ssign,vf00			; clamp above 0.0
		loi			-2.0
		maxi.xyw		ssign,ssign,i	 			; clamp to -2 below
		addw.xyw		ssign,ssign,vf00			; now.. -1 or 1	 !

		muly.xyw		angles,angles,const		; get 0-2pi to 0-4 to PITO4
		
		abs.xyw		angles,angles				; abs value
		ftoi0.xyw	iang,angles					; integer parts
		
		iaddiu 		three,vi00,3
		
		mtir			x_int,iangx
		iand   		x_int,x_int,three
		lq.x   		flip,FBT(x_int):FBT
		lq.x   		sin_sign,SST(x_int):SST
		lq.x  		cos_sign,CST(x_int):CST
		
		mtir			y_int,iangy
		iand   		y_int,y_int,three
		lq.y   		flip,FBT(y_int):FBT
		lq.y   		sin_sign,SST(y_int):SST
		lq.y  		cos_sign,CST(y_int):CST

		mtir			w_int,iangw
		iand   		w_int,w_int,three
		lq.w   		flip,FBT(w_int):FBT
		lq.w   		sin_sign,SST(w_int):SST
		lq.w  		cos_sign,CST(w_int):CST
			
		
		mul.xyw		sin_sign,ssign,sin_sign
		
		itof0.xyw	ifang,iang
		sub.xyw		angles,angles,ifang	   		; angle 0-1
		
		mul.xyw		ang2,angles,angles
		mul.xyw		ang3,ang2,angles
		mul.xyw		ang4,ang2,ang2
		mul.xyw		ang5,ang3,ang2
		mul.xyw		ang6,ang3,ang3
		mul.xyw		ang7,ang3,ang4
		mul.xyw		ang8,ang4,ang4
		mul.xyw		ang9,ang5,ang4
		mul.xyw		ang10,ang5,ang5
		
		mulaz.xyw		acc,angles,const
     	maddax.xyw	acc,ang3,s_taylor
     	madday.xyw	acc,ang5,s_taylor
     	maddaz.xyw	acc,ang7,s_taylor
   	maddw.xyw	tsin,ang9,s_taylor
		
		
		mula.xyw		acc,ones,ones
		maddaw.xyw	acc,ang2,const
		maddax.xyw	acc,ang4,c_taylor
		madday.xyw	acc,ang6,c_taylor
		maddaz.xyw	acc,ang8,c_taylor
		maddw.xyw	tcos,ang10,c_taylor
		
		sub.xyw		mflip,ones,flip
		mula.xyw		acc,tcos,flip  		; flip=1.0 if flip, else 0.0
		madd.xyw		sin,tsin,mflip
		
		mula.xyw		acc,tsin,flip  		; flip=1.0 if flip, else 0.0
		madd.xyw		cos,tcos,mflip 		
		
		mul.xyw		sin,sin,sin_sign	; set correct signs
		mul.xyw		cos,cos,cos_sign

	
; now have sin/cos of theta/phi in xy of sin,cos

;	out_mat->m[0][0]=-s_theta*cos_phi;
;	out_mat->m[0][1]=-cos_theta;
;	out_mat->m[0][2]=s_theta*s_phi;
;	out_mat->m[0][3]=0.0;

;	out_mat->m[1][0]=-cos_theta*cos_phi;
;	out_mat->m[1][1]=s_theta;
;	out_mat->m[1][2]=cos_theta*s_phi;
;	out_mat->m[1][3]=0.0;

;	out_mat->m[2][0]=-s_phi;
;	out_mat->m[2][1]=0.0;
;	out_mat->m[2][2]=-cos_phi;
;	out_mat->m[2][3]=0.0;

;	out_mat->m[3][0]=r*s_theta*cos_phi;
;	out_mat->m[3][1]=r*cos_theta;
;	out_mat->m[3][2]=-r*s_theta*s_phi;
;	out_mat->m[3][3]=1.0;

			vzero		objMat[0]
			vzero		objMat[1]
			vzero		objMat[2]
			vzero		tmp

			sub.x		objMat[0],vf00,sin		; -s_theta
			subx.y	objMat[0],vf00,cos		; -c_theta
			addx.z	objMat[0],vf00,sin		; s_theta

			sub.x		objMat[1],vf00,cos		; -cos_theta
			addx.y	objMat[1],vf00,sin		; sin_theta
			addx.z	objMat[1],vf00,cos		; cos_theta

			suby.x	objMat[2],vf00,sin		; -sin_phi
			suby.z	objMat[2],vf00,cos		; -cos_phi

			mr32 		tmp,sin						; .x=sin
			mr32		tmp,tmp						; .w=sin
			mr32 		tmp,tmp 						; .z=sin_phi
			mr32.x	tmp,cos						; cos_phi


			mul.xz	objMat[0],objMat[0],tmp
			mul.xz	objMat[1],objMat[1],tmp
			sub.z		angles,vf00,angles		; -r

			mulz.xyz	objMat[3],objMat[0],angles
			move.w	objMat[3],vf00



		

		.endm
