; Copyright (C)2002, Sony Computer Entertainment America Inc.
; This file is subject to the terms and conditions of the GNU
; General Public Licence Version 2.  See the file "COPYING"
; in the main directory of this archive for more details.


       	.include	"i/vumacros.m"	; general macros
	.include	"i/invite.i"	; main structures in vu memory
	.include	"i/invite.m"	; macros for the invite

	.init_vf_all
	.init_vi_all

; 200,000 points in starfield

NPOINTS_INNER	.equ	64 		
NPOINTS_OUTER	.equ	3200

	.name	vu1_msg

	--enter
	--endenter

;	set up constants


     	ram_xyzw   	ib_angConstants(vi00),3.4e+38,0.636619772,1.570796327,-1.233700551		; max_float,pito4,sin_1,cos_2
	ram_xyzw	ib_sTaylor(vi00),-0.645964098,7.9692626e-2,-4.6817541e-3,1.6044118e-4		; sin3-sin9
	ram_xyzw	ib_cTaylor(vi00),0.253669508,-2.0863481e-2,9.1926027e-04,2.5202042e-05	  	; cos4-cos10
	ram_xyzw	ib_TellyInfo(vi00),640.0,224.0,2.0,170.0       					; width,height,aspect,eye_distance

      ;	--barrier

; nasty hack to make giftag for points.. in the old days.. couldn't preload vu ram..
	
	vzero		ptGt
	isetu		tmp,0x41  			; rgba,xyzf2
	mfir.z		ptGt,tmp
	loiy		ptGt,1.357370298e-19
	sq		ptGt,ib_Pt_gifTag(vi00)		; save point
	loiy		ptGt,1.361605463e-19	  	; now set up line
	sq		ptGt,ib_Ln_gifTag(vi00)	  	; save line

	; let's be real lazy and build persp matrix

	lq		tellyInfo,ib_TellyInfo(vi00)

	loixyzw		pmat[0],0.0,0.0,16399.0137,1.0
	vzero		pmat[1]
	vzero		pmat[2]
	
	subw.y		pmat[1],vf00,tellyInfo
	
	mulw.z		pmat[2],TellyInfo,TellyInfo
	mr32		pmat[2],pmat[2]
	mr32		pmat[2],pmat[2]

	vzero		pmat[3]
	loiz		pmat[3],16793614.02   	; set [NEAR*FAR*(MIN-MAX)/(NEAR-FAR)


	saveMatrix	pmat,ib_PerspMatrix,vi00

	
		
	; make camera location
	; camera orientation is unit matrix for now



	lq		angles,ib_CameraLoc(vi00)
	addw.y		angles,angles,angles	     	; update phi with phi_inc
	sq.y		angles,ib_CameraLoc(vi00)	; save out

	; modify theta by some sine value?


	muly.w		angles,vf00,angles		; set w
	loi		0.7
	muli.w		angles,angles,i


	
	inFacePolar					; sin/cos.w valid after!
	loi		0.4
	muli.w		sin,sin,i
	loi		1.5708
	addi.w		angles,sin,i
	mr32.z		angles,angles
	mr32.y		angles,angles
	mr32.x		angles,angles
	sq.x		angles,ib_CameraLoc(vi00)	; save out

	mul.w		cos,cos,cos
	loi		100.0
	muli.w		cos,cos,i
	loi		210.0
	addi.w		cos,cos,i
	mr32.z		cos,cos
	sq.z		cos,ib_CameraLoc(vi00)	; save out


	
	saveMatrix	objMat,ib_CameraOrientation,vi00 	; save it out 

	loadMatrix	camMat,ib_CameraOrientation,vi00

	; the world->camera is then inverse of above...

	invOrthoMatrix	WorldToCam,camMat  			; invert the cam xform
	saveMatrix	WorldToCam,ib_toCamera,vi00		; save to camera

	; load up the perspective matrix

	loadMatrix	persp,ib_PerspMatrix,vi00  		; load perspective matrix
	mat_x_mat	WorldToScreen,WorldToCam,persp	   	; world to screen is perspective matrix . cam matrix
	saveMatrix	WorldToScreen,ib_toScreen,vi00		; save world to screen

	; now - build the object orientation matrix..

	lq.xyz		angles,ib_objRot(vi00)			; load up angles
	loixyz		ang_inc,2.0e-2,1.5e-2,3.0e-2   		; get angle increments
	add.xyz		angles,ang_inc,angles			; update angles
	sq.xyz		angles,ib_objRot(vi00)			; save rotation angles
	makeRotate 		       			; build a rotate matrix from angles

	scaleMat_XYZi	ObjMat,400.0   					; size of the stars

	loixyzw		gsCentre,2048.0,2048.0,0.0,0.0		; if bothered to clip

; make object to screen matrix

	mat_x_mat	ObjToScreen,objMat,WorldToScreen		

; camera sits at origin, faces X direction...so

	izero		buff_offset
	isetu		buff_size,RBUFF_SIZE
	lq		giftag,ib_Pt_gifTag(vi00)		; read giftag
	isetu		nloop,NPOINTS_INNER
	
	isetbig		eop,0x8000				; get eop
	ior		nloop,eop,nloop				; set nloop in giftag
	
	mfir.x		giftag,nloop
	
	sq		giftag,ST_BASE0(vi00)			; store giftag
	sq		giftag,ST_BASE1(vi00)			; store giftag

	isetu		nOuterLoops,NPOINTS_OUTER

	vzero		rSeed

	loixyzw		rMul,1.31357231,1.79512412,17.2341241,3.214341
	loixyzw		rAdd,0.71234121,0.1245121,0.313815147,0.6185812


pt_outer_loop:
	
	iaddiu		buffer,buff_offset,ST_BASE0   			; get buffer start
	iaddiu		out_p,buffer,1					; out_p = buffer+1
	isub		buff_offset,buff_size,buff_offset		; flip buffers
	iaddiu		end_p,out_p,NPOINTS_INNER*pt_sizeof
	loixyzw		colb,60.0,60.0,96.0,128.0
	mfir		fx_pt,vi00
	loiz		fx_pt,200.0
	ftoi0.z		fx_pt,fx_pt


pt_inner_loop:
	--LoopCS	10,10

	mula		rSeed,rSeed,rMul    		; pitiful random number generator
	maddw		rSeed,rAdd,vf00
	ftoi0		rI,rSeed
	itof0		rI,rI
	sub		rSeed,rSeed,rI			; rSeed now [0-1.0)

	mulw		col,colb,rSeed
	ftoi0		RGBA,col

	loi		0.5
	subi		pt,rSeed,i			; now [-0.5,0.5)

	mulax		ACC,ObjToScreen[0],pt
	madday		ACC,ObjToScreen[1],pt
	maddaz		ACC,ObjToScreen[2],pt
	maddw		sc_pt,ObjToScreen[3],vf00	; 
						  	
	div	 	q,vf00w,sc_ptw
	mulq.xyz	sc_pt,sc_pt,q	
	add.xy		sc_pt,gsCentre,sc_pt
	ftoi4.xy    	fx_pt,sc_pt	       		; so fx_pt.z is always very far away..
	sq  		fx_pt,pt_xyzf2(out_p)
	sq    	    	RGBA,pt_rgba(out_p)
	iaddiu		out_p,out_p,pt_sizeof

	ibne		out_p,end_p,pt_inner_loop
	
       	xgkick		buffer

	idec		nOuterLoops
	ibne		nOuterLoops,vi00,pt_outer_loop




	; now - make the angle matrix


	; letters are in     XY plane.. centred around Y axis.. at Z=10
	
	vzero		RGBA
	isetu		tmp,255
	mfir.w		RGBA,tmp

	lq		giftag,ib_Ln_gifTag(vi00)		; read giftag
	sq		giftag,ST_BASE0(vi00)			; store giftag
	sq		giftag,ST_BASE1(vi00)			; store giftag

; now - display message rings..

	isetu		ring_p,MsgBase				; hmm

ring_loop:
	ilw.x		msg_p,rm_RingConsts(ring_p)			; get start of message
	vzero		AngBase
	lq.y		AngBase,rm_AngRot(ring_p)		; read angular rotation
	lq.yzw		ringConsts,rm_RingConsts(ring_p)
	ibeq		msg_p,vi00,done_rings		

	loix		ringConsts,120.0			; default radius
	muly.x		ringConsts,ringConsts,ringConsts  	; mul by scale


txt_message_loop:
	
	ilw.w		char_p,(msg_p)
	lqi.xyz		RGBA,(msg_p++)
	ibeq		char_p,vi00,done_msg

txt_char_loop:
	ilw.x		nLines,(char_p)
	ibeq   		nLines,vi00,done_char

	iaddiu		char_p,char_p,1
	move		angles,angBase
       	
	--barrier
	makeRotate 		       			; build a rotate matrix from angles
       	--barrier
	loadMatrix	w2s,ib_toScreen,vi00  	   		; load perspective matrix
      	mat_x_mat	txtToScreen,objMat,w2s
	
	mulz.xyz	tmp,txtToScreen[1],ringConsts		; do offset by y_offset
	add.xyz		txtToScreen[3],tmp,txtToScreen[3]	; add it in

	muly		txtToScreen[0],txtToScreen[0],ringConsts	; scale X part

	iaddiu 		buffer,buff_offset,ST_BASE0   			; get buffer start

      	isetbig		eop,0x8000				; get eop
	iadd		eop,eop,nLines
	iadd		eop,eop,nLines
	isw.x		eop,(buffer)	 			; set nloop

	isub   		buff_offset,buff_size,buff_offset		; flip buffers
	iaddiu		out_p,buffer,1

	iadd		end_p,char_p,nLines
	
txt_line_loop:
	--LoopCS	1,10
		lq 	line,(char_p)
		
		mulax  	acc,txtToScreen[0],line
		madday	acc,txtToScreen[1],line
		maddax	acc,txtToScreen[2],ringConsts
		maddw	sc_pt,txtToScreen[3],vf00

		div	q,vf00w,sc_ptw
		mulq 	sc_pt,sc_pt,q	
   		add.xy	sc_pt,gsCentre,sc_pt
		ftoi4	fx_pt,sc_pt
		
		sq	RGBA,ln_rgba_0(out_p)						; v0
		sq	fx_pt,ln_xyzf2_0(out_p)


		mulaz	acc,txtToScreen[0],line
		maddaw	acc,txtToScreen[1],line
		maddax 	acc,txtToScreen[2],ringConsts
		maddw 	sc_pt,txtToScreen[3],vf00

		div  	q,vf00w,sc_ptw
		mulq  	sc_pt,sc_pt,q	
   		add.xy	sc_pt,gsCentre,sc_pt
		ftoi4 	fx_pt,sc_pt
		
		sq    	fx_pt,ln_xyzf2_1(out_p)
		sq	RGBA,ln_rgba_1(out_p)	  			; v1

		iaddiu	out_p,out_p,ln_sizeof
		iaddiu	char_p,char_p,1

      	 	ibne	end_p,char_p,txt_line_loop
	
	xgkick		buffer


done_char:

      	addw.y		angBase,angBase,ringConsts
	b		txt_message_loop		; get next char


done_msg:
	lq		AngBase,rm_AngRot(ring_p) 	; advance angular rotation		
	loi		0.6
	muli.x		AngBase,AngBase,i
	addx.y		AngBase,AngBase,AngBase
	sq.y		AngBase,rm_AngRot(ring_p)
	iaddiu		ring_p,ring_p,rm_sizeof		; advance ring ptr
	b		ring_loop

done_rings:
	--exit
	--endexit

;   all is lameness (c) stewart/LamersUnitedFC .. 2001 
