

;
;	well - it's time to make some compromises:
;		
;	CIDs are always store relative to p_pwCID
;	the mat stack is at p_pwSCMD..why.. well - it is....

DEPTH_MASK	.equ	H'1f


	ilw.w		hed,d_hrcXleft(vi00)w		; read the head pointer
	lq.w		tmp,d_hrcYup(vi00)		; read time
	add.x		time,vf00,tmp[w]		; time.x = time

	ilw.x		nHE,(hed)x
	ilw.y		nKTE,(hed)y
	ilw.z		kteBase,(hed)z
	iadd		kteBase,hed,kteBase		; kteBase!

;********************************************************
;
;	now - search the keys
;
;********************************************************
	
	iadd		kte_p,kteBase,vi00		; set up for key search!

	isetiu		negx_bit,0x80			; 0x80

; horrible while loop!


find_key:
	lq.x		ntime,1(kte_p) 			; load time of next one
	sub.x		tmp,time,ntime			; time-next_time
	fmand		bit,negx_bit		       	
	ibne		bit,vi00,found_key    		; branch if (time-next_time)<0

	iaddiu		kte_p,kte_p,1
	b		find_key

found_key:
	
	lq.x		kt,(kte_p) 			; key time at x
	lq.z		rdt,(kte_p)			; 1/delta next

	sub.x		localt,time,kt
	mul.x		interp,localt,rdt[z]		; interp=(t-kt1)/(kt2-kt1)

	ilw.y		now_p,(kte_p)y
	ilw.y		next_p,1(kte_p)y



	iadd		now_p,hed,now_p			; make absolute
	iadd		next_p,hed,next_p		; make absolute


;********************************************************
;
;	now - configure for hierarchy processing
;
;********************************************************


	lq.xyz		h0,d_hrcXleft(vi00)
	lq.xyz		h1,d_hrcYup(vi00)
	lq.xyz		h2,d_hrcZahead(vi00)
	lq.xyz		h3,d_hrcLoc(vi00)

	sq.xyz		h0,p_pwSCMD+0(vi00)
	sq.xyz		h1,p_pwSCMD+1(vi00)
	sq.xyz		h2,p_pwSCMD+2(vi00)
	sq.xyz		h3,p_pwSCMD+3(vi00)

;********************************************************
;	save out hrc
;********************************************************

	iaddi		nHE,nHE,-1		; skip first
	iaddiu		he_p,hed,2+3		; skip the header + the first he


	max		ones,vf00,vf00[w]	
	lq		s_taylor,i_sinTaylor(vi00)
	lq		c_taylor,i_cosTaylor(vi00)
	lq		a_const,i_angConsts(vi00)
	loi	      	-2.0
	iaddiu		depth_mask,vi00,DEPTH_MASK









hrc_loop:
;
;	
;
; 	read data from hed

	ilw.x		depth,(he_p)x	 		; read depth
	iand		depth,depth,depth_mask		; mask the depth	
	ilw.w		cid_offset,(he_p)w		; read offset

	lq.xyz		matC_0,0(he_p)			; read the jo info
	lq.xyz		matC_1,1(he_p)
	lq.xyz		matC_2,2(he_p)
	


	ilw.w		rot_loc,1(he_p)
	ilw.w		tra_loc,2(he_p)

;**************************************************************************************************
;**************************************************************************************************
;	decode rotate
;**************************************************************************************************
;**************************************************************************************************

	ibne		rot_loc,vi00,rot_is_const
	
;**********
; KEY_ROT
;**********
	lqi.xyz		rot_now,(now_p++)
	lqi.xyz		rot_next,(next_p++)

	mula.xyz	acc,rot_now,vf00[w] 			;  A+tB-tA
	madd.xyz	acc,rot_next,interp[x]
	msub.xyz	Rotate,rot_now,interp[x]


	
	b		done_rot

	
;**********
; CONST_ROT
;**********
		
rot_is_const:	

	iadd		rot_loc,rot_loc,hed
	lq		Rotate,0(rot_loc)

done_rot:


;**************************************************************************************************
;**************************************************************************************************
;	decode translate
;**************************************************************************************************
;**************************************************************************************************

	ibne		tra_loc,vi00,tra_is_const

;**********
; KEY_TRA
;**********

	lqi.xyz		tra_now,(now_p++)
	lqi.xyz		tra_next,(next_p++)


	mula.xyz	acc,tra_now,vf00[w] 			;  A+tB-tA
	madd.xyz	acc,tra_next,interp[x]
	msub.xyz	Translate,tra_now,interp[x]
	
	b		done_tra
	
;**********
; CONST_ROT
;**********

tra_is_const:	

	iadd		tra_loc,tra_loc,hed
	lq		Translate,0(tra_loc)



done_tra:

;**********************************************************
; now access various things..
;**********************************************************

	lq.xyz		pmat_0,p_pwSCMD-4+0(depth)
	lq.xyz		pmat_1,p_pwSCMD-4+1(depth)
	lq.xyz		pmat_2,p_pwSCMD-4+2(depth)
	lq.xyz		pmat_3,p_pwSCMD-4+3(depth)



	mfir.w	      	sin,vi00			; basically, w has to be zero!
	mfir.w	      	cos,vi00			; for the mr32 at end to work..

	mul.xyz      	ssign,Rotate,a_const[x]		; max value
	mini.xyz	ssign,ssign,vf00[x]      	; clamp above 0.0	
	max.xyz      	ssign,ssign,i	 		; clamp to -2 below
	add.xyz      	ssign,ssign,vf00[w]		; now.. -1 or 1	 !

	abs.xyz		Rotate,Rotate			; abs value
	ftoi0.xyz	iang,Rotate			; integer parts
	
	iaddiu 		three,vi00,3
	
	mtir	      	x_int,iang[x]
	iand   		x_int,x_int,three

	lq.x   		flip,i_FBT(x_int)
	lq.x   		sin_sign,i_SST(x_int)
	lq.x  		cos_sign,i_CST(x_int)
	
	mtir	      	y_int,iang[y]
	iand   		y_int,y_int,three

	lq.y   		flip,i_FBT(y_int)
	lq.y   		sin_sign,i_SST(y_int)
	lq.y  		cos_sign,i_CST(y_int)
	
	mtir   		z_int,iang[z]
	iand   		z_int,z_int,three

	lq.z   		flip,i_FBT(z_int)
	lq.z 	      	sin_sign,i_SST(z_int)
	lq.z  		cos_sign,i_CST(z_int)
	
	mul.xyz		sin_sign,ssign,sin_sign
	
	itof0.xyz	ifang,iang
	sub.xyz		Rotate,Rotate,ifang	   		; angle 0-1
	
	mul.xyz		ang2,Rotate,Rotate
	mul.xyz		ang3,ang2,Rotate
	mul.xyz		ang4,ang2,ang2
	mul.xyz		ang5,ang3,ang2
	mul.xyz		ang6,ang3,ang3
	mul.xyz		ang7,ang3,ang4
	mul.xyz		ang8,ang4,ang4
	mul.xyz		ang9,ang5,ang4
	mul.xyz		ang10,ang5,ang5
	
	mula.xyz	acc,Rotate,a_const[z]
     	madda.xyz	acc,ang3,s_taylor[x]
     	madda.xyz	acc,ang5,s_taylor[y]
      	madda.xyz	acc,ang7,s_taylor[z]
       	madd.xyz	tsin,ang9,s_taylor[w]
	
	mula.xyz   	acc,ones,ones
	madda.xyz	acc,ang2,a_const[w]
	madda.xyz	acc,ang4,c_taylor[x]
	madda.xyz	acc,ang6,c_taylor[y]
	madda.xyz	acc,ang8,c_taylor[z]
	madd.xyz	tcos,ang10,c_taylor[w]
	
	sub.xyz		mflip,ones,flip
	mula.xyz   	acc,tcos,flip  		; flip=1.0 if flip, else 0.0
	madd.xyz   	sin,tsin,mflip
	
	mula.xyz   	acc,tsin,flip  		; flip=1.0 if flip, else 0.0
	madd.xyz   	cos,tcos,mflip 		
	
	mul.xyz		sin,sin,sin_sign	; set correct signs
	mul.xyz		cos,cos,cos_sign



;	out_mat->m[0][0] = cy*cz;
;	out_mat->m[0][1] = cy*sz;
;	out_mat->m[0][2] = -sy;
;	out_mat->m[0][3] = 0;

;	out_mat->m[1][0] = sx*sy*cz-sz*cx;
;	out_mat->m[1][1] = sx*sy*sz+cx*cz;
;	out_mat->m[1][2] = sx*cy;
;	out_mat->m[1][3] = 0;

;	out_mat->m[2][0] = cx*sy*cz+sx*sz;
;	out_mat->m[2][1] = cx*sy*sz-sx*cz;
;	out_mat->m[2][2] = cx*cy;
;	out_mat->m[2][3] = 0;

;	out_mat->m[3][0] = 0.0f;
;	out_mat->m[3][1] = 0.0f;
;	out_mat->m[3][2] = 0.0f;
;	out_mat->m[3][3] = 1.0f;

; zero input matrix, apart from row3, which is vf00
		
        add.x		czsz_,vf00,cos[z]	 ; [cz -- -- -- ]
        add.y		czsz_,vf00,sin[z]	 ; [cz sz -- --
        mul.xy		xfrm[0],czsz_,cos[y]	 ; 
        sub.z		xfrm[0],vf00,sin[y]	 ; done row 0		

        add.z		czsz_,vf00,cos[y]	 ; czsz_=czszcy
        mul.xy		czsz_,czsz_,sin[y]  	 ; czsz_ = sycz,sysz,cy

	mr32.yz		cos,cos	  		  ; y=z term, z= 0
	mr32.yz 	sin,sin			  ; likewise	


	mula.xyz	xfrm[1],czsz_,sin[x]
	msub.xz		xfrm[1],cos,sin[y]
	madd.y		xfrm[1],cos,cos[x]


	mula.xyz	xfrm[2],czsz_,cos[x]
	madd.xz		xfrm[2],sin,sin[y]
	msub.y		xfrm[2],cos,sin[x]




; that's xfrm made.

	; [[R] [mat_C]]
	; -Translate-

    	mul.xyz		acc,matC_0,xfrm[0][x]
    	madd.xyz	acc,matC_1,xfrm[0][y]
    	madd.xyz	txfrm[0],matC_2,xfrm[0][z]

    	mula.xyz	acc,matC_0,xfrm[1][x]
    	madda.xyz	acc,matC_1,xfrm[1][y]
    	madd.xyz	txfrm[1],matC_2,xfrm[1][z]


    	mul.xyz		acc,matC_0,xfrm[2][x]
    	madda.xyz 	acc,matC_1,xfrm[2][y]
    	madd.xyz	txfrm[2],matC_2,xfrm[2][z]

; now mul by parent

	mul.xyz		acc,pmat_0,txfrm[0][x]
	madd.xyz	acc,pmat_1,txfrm[0][y]
	madd.xyz	txfrm[0],pmat_2,txfrm[0][z]

	mul.xyz		acc,pmat_0,txfrm[1][x]
	madd.xyz	acc,pmat_1,txfrm[1][y]
	madd.xyz	txfrm[1],pmat_2,txfrm[1][z]

	mul.xyz		acc,pmat_0,txfrm[2][x]
	madd.xyz	acc,pmat_1,txfrm[2][y]
	madd.xyz	txfrm[2],pmat_2,txfrm[2][z]

	mul.xyz		acc,pmat_0,Translate[x]
	madd.xyz	acc,pmat_1,Translate[y]
	madd.xyz	acc,pmat_2,Translate[z]
	madd.xyz	txfrm[3],pmat_3,vf00[w]


;	well - txfrm is the transform


;*****************************************************
;	save it out to the stack
;*****************************************************

	sq.xyz		txfrm[0],p_pwSCMD+0(depth)
	sq.xyz		txfrm[1],p_pwSCMD+1(depth)
	sq.xyz		txfrm[2],p_pwSCMD+2(depth)
	sq.xyz		txfrm[3],p_pwSCMD+3(depth)

;*****************************************************
; now saev ti out to p_pwCID table
;*****************************************************

	sq.xyz		txfrm[0],p_pwCID+0(cid_offset)
	sq.xyz		txfrm[1],p_pwCID+1(cid_offset)
	sq.xyz		txfrm[2],p_pwCID+2(cid_offset)
	sq.xyz		txfrm[3],p_pwCID+3(cid_offset)

;  	sq.xyz		h0,p_pwCID+0(cid_offset)
;  	sq.xyz		h1,p_pwCID+1(cid_offset)
;  	sq.xyz		h2,p_pwCID+2(cid_offset)
;  	sq.xyz		h3,p_pwCID+3(cid_offset)

	iaddiu		he_p,he_p,3			; advance hed
	iaddi		nHE,nHE,-1

	ibne		nHE,vi00,hrc_loop






